from tkinter import *


FontLarge = ('Arial', 12)

class SelectAdapter(Toplevel):
    def __init__(self, parent, **kwargs):
        Toplevel.__init__(self, parent)
        self.grab_set()

        title=kwargs.pop('title')
        contents = kwargs.pop('adapterDic')

        frame=Frame(self, **kwargs)
        frame.pack()
        self.label = Label(frame, text=title)
        self.label.pack(padx=10,pady=10)

        self.lst = Listbox(frame)
        self.lst.config(width=100)
        self.lst.pack(padx=10,pady=10)
        self.lst.bind("<<ListboxSelect>>", self.on_lst_select)

        self.btnOk = Button(frame, text='Ok', font=FontLarge, command=self.on_btn_ok_click)
        self.btnOk.pack(side='left', padx=100,pady=20)

        self.btnCancel = Button(frame, text='Cancel', font=FontLarge, command=self.on_btn_cancel_click)
        self.btnCancel.pack(side='right', padx=100,pady=20)

        # fill-up list based on given dictionary
        self.selectedIndex = -1
        self.lstData = []

        for a in contents:
            for dev in contents[a]:
                self.lst.insert('end', '{0:4} {1}'.format(a, dev))
                self.lstData.append(dev)

    def show(self):
        self.wm_deiconify()
        self.lst.focus_force()
        self.wait_window()
        if self.selectedIndex < 0:
            return None
        return self.lstData[self.selectedIndex]


    def on_btn_ok_click(self):
        self.destroy()

    def on_btn_cancel_click(self):
        self.selectedIndex = -1
        self.destroy()

    def on_lst_select(self, event):
        selection = event.widget.curselection()
        index = selection[0]
        self.selectedIndex = index

